# Copyright 1999-2003 Gentoo Technologies, Inc.
# Distributed under the terms of the GNU General Public License v2
# $Header: $

DESCRIPTION="Tivoli Storage Manager (TSM) Backup/Archive (B/A) Client"
HOMEPAGE="http://www.tivoli.com/"

# Base package
SRC_URI_BA="TIVsm-BA.i386.rpm"
SRC_URI_API="TIVsm-API.i386.rpm"

BASE_URI="ftp://ftp.software.ibm.com/storage/tivoli-storage-management/maintenance/client/v5r2/Linux/Linux86/v522/"
SRC_URI="${BASE_URI}${SRC_URI_BA} ${BASE_URI}${SRC_URI_API}"

RESTRICT="nostrip fetch" # Breaks libPiIMG.ss and libPiSNAP.so
LICENSE="as-is"
SLOT="0" # There should only be one version installed at any give time.
KEYWORDS="x86"
IUSE=""
DEPEND="sys-libs/lib-compat app-arch/rpm"
RDEPEND="sys-libs/lib-compat" # Doesn't need rpm once it's installed
S="${WORKDIR}" # Different than the default of ${WORKDIR}/${P}

src_unpack() {
	for x in ${SRC_URI_BA} ${SRC_URI_API}
	do
		einfo "Extracting: ${x}"
		rpm2cpio ${DISTDIR}/${x} | cpio --extract --make-directories --unconditional
	done
}

src_install() {
	cp -a opt ${D}
	chmod -R go+rX ${D}/opt/tivoli # Allow all users to access TSM tools

	dodir /etc/tivoli
	keepdir /etc/tivoli

	cp -a ${S}/opt/tivoli/tsm/client/ba/bin/dsm.sys.smp ${D}/etc/tivoli/dsm.sys
	echo '   PasswordDir "/etc/tivoli/"'  >> ${D}/etc/tivoli/dsm.sys
	echo '   PasswordAccess generate'  >> ${D}/etc/tivoli/dsm.sys
	# Added the hostname to be more friendly, the admin will need to edit this file anyway
	echo '   NodeName' `hostname` >> ${D}/etc/tivoli/dsm.sys
	echo '   ErrorLogName "/var/log/dsmerror.log"' >> ${D}/etc/tivoli/dsm.sys
	echo '   SchedLogName "/var/log/dsmsched.log"' >> ${D}/etc/tivoli/dsm.sys
	dosym /etc/tivoli/dsm.sys /opt/tivoli/tsm/client/ba/bin/dsm.sys

	cp -a ${S}/opt/tivoli/tsm/client/ba/bin/dsm.opt.smp ${D}/etc/tivoli/dsm.opt
	dosym /etc/tivoli/dsm.opt /opt/tivoli/tsm/client/ba/bin/dsm.opt

	# This creates the symlinks for the API libs
	dodir /usr/lib
	dosym /opt/tivoli/tsm/client/api/bin/libct_cu.so /usr/lib/libct_cu.so
	dosym /opt/tivoli/tsm/client/api/bin/libdmapi.so /usr/lib/libdmapi.so
	dosym /opt/tivoli/tsm/client/api/bin/libgpfs.so /usr/lib/libgpfs.so
	dosym /opt/tivoli/tsm/client/api/bin/libha_gs_r.so /usr/lib/libha_gs_r.so
	dosym /opt/tivoli/tsm/client/api/bin/libApiDS.so /usr/lib/libApiDS.so
	
	# Setup the env
	dodir /etc/env.d
	ENV_FILE="${D}/etc/env.d/80tivoli"
	echo DSM_CONFIG="/etc/tivoli/dsm.opt" >> ${ENV_FILE}
	echo DSM_DIR="/opt/tivoli/tsm/client/ba/bin" > ${ENV_FILE}
	echo DSM_LOG="/var/log" > ${ENV_FILE}
	echo PATH="/opt/tivoli/tsm/client/admin/bin:/opt/tivoli/tsm/client/ba/bin" >> ${ENV_FILE}
	echo ROOTPATH="/opt/tivoli/tsm/client/admin/bin:/opt/tivoli/tsm/client/ba/bin" >> ${ENV_FILE}

	insinto /etc/conf.d && newins ${FILESDIR}/dsmc.conf.d dsmc 
	exeinto /etc/init.d && newexe ${FILESDIR}/dsmc.init.d dsmc 
}
